import { AfterContentInit, ChangeDetectorRef, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { matRangeDatepicker } from './datepicker';
import { matRangeDatepickerIntl } from './datepicker-intl';
/** Can be used to override the icon of a `matDatepickerToggle`. */
export declare class matRangeDatepickerToggleIcon {
}
export declare class matRangeDatepickerToggle<D> implements AfterContentInit, OnChanges, OnDestroy {
    _intl: matRangeDatepickerIntl;
    private _changeDetectorRef;
    /** Datepicker instance that the button will toggle. */
    datepicker: matRangeDatepicker<D>;
    /** Custom icon set by the consumer. */
    _customIcon: matRangeDatepickerToggleIcon;
    private _stateChanges;
    private _disabled;
    constructor(_intl: matRangeDatepickerIntl, _changeDetectorRef: ChangeDetectorRef);
    /** Whether the toggle button is disabled. */
    disabled: boolean;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    ngAfterContentInit(): void;
    _open(event: Event): void;
    private _watchStateChanges();
}
