import { matRangeDatepickerIntl } from './datepicker-intl';
import { DateAdapter } from '../datetime/date-adapter';
import { MatDateFormats } from '../datetime/date-formats';
/**
 * Possible views for the calendar.
 * @docs-private
 */
export declare type SatCalendarView = 'month' | 'year' | 'multi-year';
/**
 * A calendar that is used as part of the datepicker.
 * @docs-private
 */
export declare class RangeCalendar<D> {
    private _dateAdapter;
    private _dateFormats;
    id: any;
    ngClass: any;
    startAt: any;
    startView: any;
    minDate: any;
    maxDate: any;
    dateFilter: any;
    beginDate: any;
    endDate: any;
    rangeMode: any;
    selected: any;
    selectedChange: any;
    dateRangesChange: any;
    yearSelected: any;
    monthSelected: any;
    _userSelection: any;
    /** Whenever user already selected start of dates interval. */
    private _beginDateSelected;
    constructor(_intl: matRangeDatepickerIntl, _dateAdapter: DateAdapter<D>, _dateFormats: MatDateFormats);
    _dateSelected(date: D): void;
    _getQuarterDates(quarter: number): {
        begin: D;
        end: D;
    };
    selectQuater(quarter: number): void;
    checkQuarterSelected(quarter: number): boolean;
    onCancel(): void;
    onApply(): void;
}
